#!/usr/local/bin/perl

<<'EOT';
:: makeln - update link database
::
:: usage: %0 dir...
::
:: setup:
::  %vdisk\links		links directory
::  %sdisk\etc\links.zip	same, zipped
::
:: boot:
::	unzip links.zip ; update %PATH; run link tsr

EOT

die <<'EOT' if $#ARGV < 0;
	echo usage: makeln dir...
	echo makeln re-creates exec link database for given directories.
EOT

&getenv('VDISK');
&getenv('SDISK');

$linkpath = "$VDISK/links";
mkdir($linkpath, 0744);

"$SDISK used";

@links = ();
%seen = ();

for $DIR (@ARGV) {
	$DIR =~ tr/a-z/A-Z/;		# DOS canonical name (dir)
	
	opendir(DIR, $DIR) || next;
	@files = readdir(DIR);
	grep(/\.(com|exe)$/i && do { 
		tr/a-z/A-Z/;		# DOS canonical name (file)
		
		&create($_);
		
		# last-assign logic:
		#$seen{$_} = 1 + $#links
		#	unless defined $seen{$_};
		#$links[$seen{$_}] = "$DIR\\$_ $_\n";
		
		# first-assign logic (true path logic):
		unless (defined $seen{$_}) {
			$seen{$_} = 1;
			push(@links, "$_ $DIR\\$_\n");
		}
		
	     }, @files);
	closedir(DIR);
}

open(LINKS, ">$linkpath/link\$");
print LINKS sort @links;
close(LINKS);


sub	getenv
{
	local($_) = shift;
	eval " { 
		\$$_ = \$ENV{\'$_\'}; 
		die \"required environment variable $_ missing\n\"
			unless defined \$$_;
	} ";
}

sub	create
{
	open(FILE, ">$linkpath/" . shift);
	close(FILE);
}
